$(() => {
createTreeView('#treeviewDriveC', itemsDriveC);
createTreeView('#treeviewDriveD', itemsDriveD);
createSortable('#treeviewDriveC', 'driveC');
createSortable('#treeviewDriveD', 'driveD');
});
function createTreeView(selector, items) {
$(selector).dxTreeView({
items,
expandNodesRecursive: false,
dataStructure: 'plain',
width: 250,
height: 380,
displayExpr: 'name',
});
}
function createSortable(selector, driveName) {
$(selector).dxSortable({
filter: '.dx-treeview-item',
group: 'shared',
data: driveName,
allowDropInsideItem: true,
allowReordering: true,
onDragChange(e) {
if (e.fromComponent === e.toComponent) {
const $nodes = e.element.find('.dx-treeview-node');
const isDragIntoChild = $nodes.eq(e.fromIndex).find($nodes.eq(e.toIndex)).length > 0;
if (isDragIntoChild) {
e.cancel = true;
}
}
},
onDragEnd(e) {
if (e.fromComponent === e.toComponent && e.fromIndex === e.toIndex) {
return;
}
const fromTreeView = getTreeView(e.fromData);
const toTreeView = getTreeView(e.toData);
const fromNode = findNode(fromTreeView, e.fromIndex);
const toNode = findNode(toTreeView, calculateToIndex(e));
if (e.dropInsideItem && toNode !== null && !toNode.itemData.isDirectory) {
return;
}
const fromTopVisibleNode = getTopVisibleNode(fromTreeView);
const toTopVisibleNode = getTopVisibleNode(toTreeView);
const fromItems = fromTreeView.option('items');
const toItems = toTreeView.option('items');
moveNode(fromNode, toNode, fromItems, toItems, e.dropInsideItem);
fromTreeView.option('items', fromItems);
toTreeView.option('items', toItems);
fromTreeView.scrollToItem(fromTopVisibleNode);
toTreeView.scrollToItem(toTopVisibleNode);
},
});
}
function getTreeView(driveName) {
return driveName === 'driveC'
? $('#treeviewDriveC').dxTreeView('instance')
: $('#treeviewDriveD').dxTreeView('instance');
}
function calculateToIndex(e) {
if (e.fromComponent !== e.toComponent || e.dropInsideItem) {
return e.toIndex;
}
return e.fromIndex >= e.toIndex
? e.toIndex
: e.toIndex + 1;
}
function findNode(treeView, index) {
const nodeElement = treeView.element().find('.dx-treeview-node')[index];
if (nodeElement) {
return findNodeById(treeView.getNodes(), nodeElement.getAttribute('data-item-id'));
}
return null;
}
function findNodeById(nodes, id) {
for (let i = 0; i < nodes.length; i += 1) {
if (nodes[i].itemData.id === id) {
return nodes[i];
}
if (nodes[i].children) {
const node = findNodeById(nodes[i].children, id);
if (node != null) {
return node;
}
}
}
return null;
}
function moveNode(fromNode, toNode, fromItems, toItems, isDropInsideItem) {
const fromIndex = findIndex(fromItems, fromNode.itemData.id);
fromItems.splice(fromIndex, 1);
const toIndex = toNode === null || isDropInsideItem
? toItems.length
: findIndex(toItems, toNode.itemData.id);
toItems.splice(toIndex, 0, fromNode.itemData);
moveChildren(fromNode, fromItems, toItems);
if (isDropInsideItem) {
fromNode.itemData.parentId = toNode.itemData.id;
} else {
fromNode.itemData.parentId = toNode != null
? toNode.itemData.parentId
: undefined;
}
}
function moveChildren(node, fromItems, toItems) {
if (!node.itemData.isDirectory) {
return;
}
node.children.forEach((child) => {
if (child.itemData.isDirectory) {
moveChildren(child, fromItems, toItems);
}
const fromIndex = findIndex(fromItems, child.itemData.id);
fromItems.splice(fromIndex, 1);
toItems.splice(toItems.length, 0, child.itemData);
});
}
function findIndex(array, id) {
const idsArray = array.map((elem) => elem.id);
return idsArray.indexOf(id);
}
function getTopVisibleNode(component) {
const treeViewElement = component.element().get(0);
const treeViewTopPosition = treeViewElement.getBoundingClientRect().top;
const nodes = treeViewElement.querySelectorAll('.dx-treeview-node');
for (let i = 0; i < nodes.length; i += 1) {
const nodeTopPosition = nodes[i].getBoundingClientRect().top;
if (nodeTopPosition >= treeViewTopPosition) {
return nodes[i];
}
}
return null;
}
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="form">
<div class="drive-panel">
<div class="drive-header dx-treeview-item"
><div class="dx-treeview-item-content"><i class="dx-icon dx-icon-activefolder"></i><span>Drive C:</span></div></div
>
<div id="treeviewDriveC"></div>
</div>
<div class="drive-panel">
<div class="drive-header dx-treeview-item"
><div class="dx-treeview-item-content"><i class="dx-icon dx-icon-activefolder"></i><span>Drive D:</span></div></div
>
<div id="treeviewDriveD"></div>
</div>
</div>
</div>
</body>
</html>
.form {
display: flex;
}
.form > div {
display: inline-block;
vertical-align: top;
}
.dx-treeview-item {
box-sizing: border-box;
}
.drive-header {
min-height: auto;
padding: 0;
cursor: default;
margin-bottom: 10px;
}
.drive-panel {
padding: 20px 30px;
font-size: 115%;
font-weight: bold;
border-right: 1px solid rgba(165, 165, 165, 0.4);
height: 100%;
}
.drive-panel:last-of-type {
border-right: none;
}
const itemsDriveD = [];
const itemsDriveC = [{
id: '1',
name: 'Documents',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '2',
parentId: '1',
name: 'Projects',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '3',
parentId: '2',
name: 'About.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '4',
parentId: '2',
name: 'Passwords.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '5',
parentId: '2',
name: 'About.xml',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '6',
parentId: '2',
name: 'Managers.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '7',
parentId: '2',
name: 'ToDo.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '8',
name: 'Images',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '9',
parentId: '8',
name: 'logo.png',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '10',
parentId: '8',
name: 'banner.gif',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '11',
name: 'System',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '12',
parentId: '11',
name: 'Employees.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '13',
parentId: '11',
name: 'PasswordList.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '14',
name: 'Description.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '15',
icon: 'file',
name: 'Description.txt',
isDirectory: false,
expanded: true,
}];

<template>
<div class="form">
<div class="drive-panel">
<div
class="drive-header dx-treeview-item"
><div
class="dx-treeview-item-content"
><i class="dx-icon dx-icon-activefolder"/><span>Drive C:</span></div></div>
<DxSortable
filter=".dx-treeview-item"
group="shared"
data="driveC"
:allow-drop-inside-item="true"
:allow-reordering="true"
@drag-change="onDragChange"
@drag-end="onDragEnd"
>
<DxTreeView
id="treeviewDriveC"
data-structure="plain"
:expand-nodes-recursive="false"
ref="treeViewDriveCRef"
:items="itemsDriveC"
:width="250"
:height="380"
display-expr="name"
/>
</DxSortable>
</div>
<div class="drive-panel">
<div
class="drive-header dx-treeview-item"
><div
class="dx-treeview-item-content"
><i class="dx-icon dx-icon-activefolder"/><span>Drive D:</span></div></div>
<DxSortable
filter=".dx-treeview-item"
group="shared"
data="driveD"
:allow-drop-inside-item="true"
:allow-reordering="true"
@drag-change="onDragChange"
@drag-end="onDragEnd"
>
<DxTreeView
id="treeviewDriveD"
data-structure="plain"
:expand-nodes-recursive="false"
ref="treeViewDriveDRef"
:items="itemsDriveD"
:width="250"
:height="380"
display-expr="name"
/>
</DxSortable>
</div>
</div>
</template>
<script setup lang="ts">
import { nextTick, ref } from 'vue';
import DxTreeView, { type DxTreeViewTypes } from 'devextreme-vue/tree-view';
import DxSortable, { type DxSortableTypes } from 'devextreme-vue/sortable';
import service, { type DriveItem } from './data.ts';
import type { FileSystemItem } from './types';
type DxSortableInstance = DxSortable['instance'];
type Node = DxTreeViewTypes.Node<FileSystemItem>;
const treeViewDriveCRef = ref();
const treeViewDriveDRef = ref();
const itemsDriveC = ref(service.getItemsDriveC());
const itemsDriveD = ref(service.getItemsDriveD());
function onDragChange(e: DxSortableTypes.DragChangeEvent) {
if (e.fromComponent === e.toComponent) {
const fromNode = findNode(getTreeView(e.fromData), e.fromIndex || 0);
const toNode = findNode(getTreeView(e.toData), calculateToIndex(e));
if (toNode !== null && fromNode && isChildNode(fromNode, toNode)) {
e.cancel = true;
}
}
}
function onDragEnd(e: DxSortableTypes.DragEndEvent) {
if (e.fromComponent === e.toComponent && e.fromIndex === e.toIndex) {
return;
}
const fromTreeView = getTreeView(e.fromData);
const toTreeView = getTreeView(e.toData);
const fromNode = findNode(fromTreeView, e.fromIndex || 0);
const toNode = findNode(toTreeView, calculateToIndex(e));
if (e.dropInsideItem && toNode !== null && !toNode.itemData?.isDirectory) {
return;
}
const fromTopVisibleNode = getTopVisibleNode(e.fromComponent as DxSortableInstance);
const toTopVisibleNode = getTopVisibleNode(e.toComponent as DxSortableInstance);
const fromItems = getItems(e.fromData);
const toItems = getItems(e.toData);
if (fromNode) {
moveNode(fromNode, toNode, fromItems, toItems, e.dropInsideItem);
}
itemsDriveC.value = [...itemsDriveC.value];
itemsDriveD.value = [...itemsDriveD.value];
nextTick().then(() => {
fromTreeView.scrollToItem(fromTopVisibleNode);
toTreeView.scrollToItem(toTopVisibleNode);
});
}
function getTreeView(driveName: string) {
return driveName === 'driveC'
? treeViewDriveCRef.value.instance
: treeViewDriveDRef.value.instance;
}
function getItems(driveName: string) {
return driveName === 'driveC'
? itemsDriveC.value
: itemsDriveD.value;
}
function calculateToIndex(e: DxSortableTypes.DragEndEvent | DxSortableTypes.DragChangeEvent) {
if (e.fromComponent !== e.toComponent || e.dropInsideItem) {
return e.toIndex || 0;
}
return (e.fromIndex || 0) >= (e.toIndex || 0)
? e.toIndex || 0
: (e.toIndex || 0) + 1;
}
function findNode(treeView: DxTreeView['instance'], index: number) {
const nodeElement = treeView?.element()?.querySelectorAll('.dx-treeview-node')[index];
if (nodeElement) {
return findNodeById(treeView.getNodes(), nodeElement.getAttribute('data-item-id') || '');
}
return null;
}
function findNodeById(nodes: Node[], id: string): Node | null {
for (let i = 0; i < nodes.length; i += 1) {
if (nodes[i].itemData?.id === id) {
return nodes[i];
}
if (nodes[i].children) {
const nodeChildren = nodes[i].children;
const node = nodeChildren ? findNodeById(nodeChildren, id) : null;
if (node) {
return node;
}
}
}
return null;
}
function moveNode(
fromNode: Node,
toNode: Node | null,
fromItems: DriveItem[],
toItems: any[],
isDropInsideItem: boolean,
) {
const fromIndex = fromItems.findIndex((item) => item.id === fromNode.itemData?.id);
fromItems.splice(fromIndex, 1);
const toIndex = toNode === null || isDropInsideItem
? toItems.length
: toItems.findIndex((item) => item.id === toNode.itemData?.id);
toItems.splice(toIndex, 0, fromNode.itemData);
moveChildren(fromNode, fromItems, toItems);
if (isDropInsideItem && toNode && fromNode.itemData) {
fromNode.itemData.parentId = toNode.itemData?.id;
} else if (fromNode.itemData) {
fromNode.itemData.parentId = toNode != null
? toNode.itemData?.parentId
: undefined;
}
}
function moveChildren(node: Node, fromDataSource: DriveItem[], toDataSource: any[]) {
if (!node.itemData?.isDirectory) {
return;
}
node.children?.forEach((child) => {
if (child.itemData?.isDirectory) {
moveChildren(child, fromDataSource, toDataSource);
}
const fromIndex = fromDataSource.findIndex((item) => item.id === child.itemData?.id);
if (fromIndex !== -1) {
fromDataSource.splice(fromIndex, 1);
toDataSource.splice(toDataSource.length, 0, child.itemData);
}
});
}
function isChildNode(parentNode: Node, childNode: Node) {
let { parent } = childNode;
while (parent) {
if (parent.itemData?.id === parentNode.itemData?.id) {
return true;
}
parent = parent.parent;
}
return false;
}
function getTopVisibleNode(component: DxSortableInstance) {
if (component) {
const treeViewElement = component.element();
const treeViewTopPosition = treeViewElement.getBoundingClientRect().top;
const nodes = treeViewElement.querySelectorAll('.dx-treeview-node');
for (let i = 0; i < nodes.length; i += 1) {
const nodeTopPosition = nodes[i].getBoundingClientRect().top;
if (nodeTopPosition >= treeViewTopPosition) {
return nodes[i];
}
}
}
return null;
}
</script>
<style scoped>
.form {
display: flex;
}
.form > div {
display: inline-block;
vertical-align: top;
}
.dx-treeview-item {
box-sizing: border-box;
}
.drive-header {
min-height: auto;
padding: 0;
cursor: default;
margin-bottom: 10px;
}
.drive-panel {
padding: 20px 30px;
font-size: 115%;
font-weight: bold;
border-right: 1px solid rgba(165, 165, 165, 0.4);
height: 100%;
}
.drive-panel:last-of-type {
border-right: none;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export interface DriveItem {
id: string,
parentId?: string | undefined,
name: string,
icon: string,
isDirectory: boolean,
expanded?: boolean,
items?: DriveItem[]
}
const itemsDriveD: DriveItem[] = [];
const itemsDriveC: DriveItem[] = [{
id: '1',
name: 'Documents',
icon: 'activefolder',
isDirectory: true,
expanded: true,
parentId: undefined,
}, {
id: '2',
parentId: '1',
name: 'Projects',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '3',
parentId: '2',
name: 'About.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '4',
parentId: '2',
name: 'Passwords.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '5',
parentId: '2',
name: 'About.xml',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '6',
parentId: '2',
name: 'Managers.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '7',
parentId: '2',
name: 'ToDo.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '8',
parentId: undefined,
name: 'Images',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '9',
parentId: '8',
name: 'logo.png',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '10',
parentId: '8',
name: 'banner.gif',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '11',
parentId: undefined,
name: 'System',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '12',
parentId: '11',
name: 'Employees.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '13',
parentId: '11',
name: 'PasswordList.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '14',
parentId: undefined,
name: 'Description.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '15',
parentId: undefined,
name: 'Description.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}];
export default {
getItemsDriveC() {
return itemsDriveC;
},
getItemsDriveD() {
return itemsDriveD;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
export interface FileSystemItem {
id: string;
parentId?: string;
name: string;
icon: string;
isDirectory: boolean;
expanded?: boolean;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<div class="form">
<div class="drive-panel">
<div class="drive-header dx-treeview-item"
><div class="dx-treeview-item-content"
><i class="dx-icon dx-icon-activefolder"></i><span>Drive C:</span></div
></div
>
<dx-sortable
filter=".dx-treeview-item"
group="shared"
data="driveC"
[allowDropInsideItem]="true"
[allowReordering]="true"
(onDragChange)="onDragChange($event)"
(onDragEnd)="onDragEnd($event)"
>
<dx-tree-view
#treeviewDriveC
id="treeviewDriveC"
dataStructure="plain"
displayExpr="name"
[expandNodesRecursive]="false"
[items]="itemsDriveC"
[width]="250"
[height]="380"
>
</dx-tree-view>
</dx-sortable>
</div>
<div class="drive-panel">
<div class="drive-header dx-treeview-item"
><div class="dx-treeview-item-content"
><i class="dx-icon dx-icon-activefolder"></i><span>Drive D:</span></div
></div
>
<dx-sortable
filter=".dx-treeview-item"
group="shared"
data="driveD"
[allowDropInsideItem]="true"
[allowReordering]="true"
(onDragChange)="onDragChange($event)"
(onDragEnd)="onDragEnd($event)"
>
<dx-tree-view
#treeviewDriveD
id="treeviewDriveD"
dataStructure="plain"
displayExpr="name"
[expandNodesRecursive]="false"
[items]="itemsDriveD"
[width]="250"
[height]="380"
>
</dx-tree-view>
</dx-sortable>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core';
import { DxSortableModule, DxSortableTypes } from 'devextreme-angular/ui/sortable';
import { DxTreeViewModule, DxTreeViewComponent, DxTreeViewTypes } from 'devextreme-angular/ui/tree-view';
import { Service, FileSystemItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
type TreeView = ReturnType<AppComponent['getTreeView']>;
type Node = DxTreeViewTypes.Node<FileSystemItem>;
type Item = FileSystemItem;
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTreeViewModule,
DxSortableModule,
],
})
export class AppComponent {
@ViewChild('treeviewDriveC') treeviewDriveC: DxTreeViewComponent<FileSystemItem>;
@ViewChild('treeviewDriveD') treeviewDriveD: DxTreeViewComponent<FileSystemItem>;
itemsDriveC: FileSystemItem[];
itemsDriveD: FileSystemItem[];
constructor(service: Service) {
this.itemsDriveC = service.getItemsDriveC();
this.itemsDriveD = service.getItemsDriveD();
}
onDragChange(e: DxSortableTypes.DragChangeEvent) {
if (e.fromComponent === e.toComponent) {
const fromNode = this.findNode(this.getTreeView(e.fromData), e.fromIndex);
const toNode = this.findNode(this.getTreeView(e.toData), this.calculateToIndex(e));
if (toNode !== null && this.isChildNode(fromNode, toNode)) {
e.cancel = true;
}
}
}
onDragEnd(e: DxSortableTypes.DragEndEvent) {
if (e.fromComponent === e.toComponent && e.fromIndex === e.toIndex) {
return;
}
const fromTreeView = this.getTreeView(e.fromData);
const toTreeView = this.getTreeView(e.toData);
const fromNode = this.findNode(fromTreeView, e.fromIndex);
const toNode = this.findNode(toTreeView, this.calculateToIndex(e));
if (e.dropInsideItem && toNode !== null && !toNode.itemData.isDirectory) {
return;
}
const fromTopVisibleNode = this.getTopVisibleNode(e.fromComponent);
const toTopVisibleNode = this.getTopVisibleNode(e.toComponent);
const fromItems = fromTreeView.option('items');
const toItems = toTreeView.option('items');
this.moveNode(fromNode, toNode, fromItems, toItems, e.dropInsideItem);
fromTreeView.option('items', fromItems);
toTreeView.option('items', toItems);
fromTreeView.scrollToItem(fromTopVisibleNode);
toTreeView.scrollToItem(toTopVisibleNode);
}
getTreeView(driveName: string) {
return driveName === 'driveC'
? this.treeviewDriveC.instance
: this.treeviewDriveD.instance;
}
calculateToIndex(e: DxSortableTypes.DragChangeEvent | DxSortableTypes.DragEndEvent) {
if (e.fromComponent !== e.toComponent || e.dropInsideItem) {
return e.toIndex;
}
return e.fromIndex >= e.toIndex
? e.toIndex
: e.toIndex + 1;
}
findNode(treeView: TreeView, index: number) {
const nodeElement = treeView.element().querySelectorAll('.dx-treeview-node')[index];
if (nodeElement) {
return this.findNodeById(treeView.getNodes(), nodeElement.getAttribute('data-item-id'));
}
return null;
}
findNodeById(nodes: Node[], id: string | number): Node {
for (let i = 0; i < nodes.length; i += 1) {
if (nodes[i].itemData.id === id) {
return nodes[i];
}
if (nodes[i].children) {
const node = this.findNodeById(nodes[i].children, id);
if (node != null) {
return node;
}
}
}
return null;
}
moveNode(fromNode: Node, toNode: Node, fromItems: Item[], toItems: Item[], isDropInsideItem: boolean) {
const fromIndex = fromItems.findIndex((item) => item.id === fromNode.itemData.id);
fromItems.splice(fromIndex, 1);
const toIndex = toNode === null || isDropInsideItem
? toItems.length
: toItems.findIndex((item) => item.id === toNode.itemData.id);
toItems.splice(toIndex, 0, fromNode.itemData);
this.moveChildren(fromNode, fromItems, toItems);
if (isDropInsideItem) {
fromNode.itemData.parentId = toNode.itemData.id;
} else {
fromNode.itemData.parentId = toNode != null
? toNode.itemData.parentId
: undefined;
}
}
moveChildren(node: Node, fromDataSource: Item[], toDataSource: Item[]) {
if (!node.itemData.isDirectory) {
return;
}
node.children.forEach((child) => {
if (child.itemData.isDirectory) {
this.moveChildren(child, fromDataSource, toDataSource);
}
const fromIndex = fromDataSource.findIndex((item) => item.id === child.itemData.id);
fromDataSource.splice(fromIndex, 1);
toDataSource.splice(toDataSource.length, 0, child.itemData);
});
}
isChildNode(parentNode: Node, childNode: Node) {
let parent = childNode.parent;
while (parent !== null) {
if (parent.itemData.id === parentNode.itemData.id) {
return true;
}
parent = parent.parent;
}
return false;
}
getTopVisibleNode(component: DxSortableTypes.DragEndEvent['fromComponent']) {
const treeViewElement = component.element();
const treeViewTopPosition = treeViewElement.getBoundingClientRect().top;
const nodes = treeViewElement.querySelectorAll('.dx-treeview-node');
for (let i = 0; i < nodes.length; i += 1) {
const nodeTopPosition = nodes[i].getBoundingClientRect().top;
if (nodeTopPosition >= treeViewTopPosition) {
return nodes[i];
}
}
return null;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.form {
display: flex;
}
::ng-deep .form > div {
display: inline-block;
vertical-align: top;
}
::ng-deep .dx-treeview-item {
box-sizing: border-box;
}
::ng-deep .drive-header {
min-height: auto;
padding: 0;
cursor: default;
margin-bottom: 10px;
}
::ng-deep .drive-panel {
padding: 20px 30px;
font-size: 115%;
font-weight: bold;
border-right: 1px solid rgba(165, 165, 165, 0.4);
height: 100%;
}
::ng-deep .drive-panel:last-of-type {
border-right: none;
}
import { Injectable } from '@angular/core';
export class FileSystemItem {
id: string;
parentId?: string;
name: string;
icon: string;
isDirectory: boolean;
expanded?: boolean;
}
const itemsDriveD: FileSystemItem[] = [];
const itemsDriveC: FileSystemItem[] = [{
id: '1',
name: 'Documents',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '2',
parentId: '1',
name: 'Projects',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '3',
parentId: '2',
name: 'About.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '4',
parentId: '2',
name: 'Passwords.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '5',
parentId: '2',
name: 'About.xml',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '6',
parentId: '2',
name: 'Managers.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '7',
parentId: '2',
name: 'ToDo.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '8',
name: 'Images',
isDirectory: true,
icon: 'activefolder',
expanded: true,
}, {
id: '9',
parentId: '8',
name: 'logo.png',
isDirectory: false,
icon: 'file',
expanded: true,
}, {
id: '10',
parentId: '8',
name: 'banner.gif',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '11',
name: 'System',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '12',
parentId: '11',
name: 'Employees.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '13',
parentId: '11',
name: 'PasswordList.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '14',
name: 'Description.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '15',
name: 'Description.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}];
@Injectable()
export class Service {
getItemsDriveC(): FileSystemItem[] {
return itemsDriveC;
}
getItemsDriveD(): FileSystemItem[] {
return itemsDriveD;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, { useCallback, useRef, useState } from 'react';
import TreeView from 'devextreme-react/tree-view';
import type { TreeViewTypes, TreeViewRef } from 'devextreme-react/tree-view';
import Sortable, { type SortableTypes } from 'devextreme-react/sortable';
import { itemsDriveC as originItemsDriveC, itemsDriveD as originItemsDriveD } from './data.ts';
import type { FileSystemItem } from './types.ts';
type Node = TreeViewTypes.Node<FileSystemItem>;
const getStateFieldName = (driveName: string): string => (driveName === 'driveC'
? 'itemsDriveC'
: 'itemsDriveD');
const calculateToIndex = (e: SortableTypes.DragChangeEvent): number | undefined => {
if (e.fromComponent !== e.toComponent || e.dropInsideItem) {
return e.toIndex;
}
return (e.fromIndex && e.toIndex) && (e.fromIndex >= e.toIndex
? e.toIndex
: e.toIndex + 1);
};
const findNode = (treeView: any, index: string | number | undefined): Node | null => {
if (index === undefined) {
return null;
}
const nodeElement = treeView.element().querySelectorAll('.dx-treeview-node')[index];
if (nodeElement) {
return findNodeById(treeView.getNodes(), nodeElement.getAttribute('data-item-id'));
}
return null;
};
const findNodeById = (nodes: Node[], id: string | number): Node | null => {
for (let i = 0; i < nodes.length; i += 1) {
if (nodes[i].itemData?.id === id) {
return nodes[i];
}
if (nodes[i].children) {
const node = findNodeById(nodes[i].children ?? [], id);
if (node != null) {
return node;
}
}
}
return null;
};
const moveNode = (fromNode: Node, toNode: Node, fromItems: FileSystemItem[], toItems: FileSystemItem[], isDropInsideItem: boolean): void => {
if (!fromNode.itemData || !toNode.itemData) {
return;
}
const fromIndex = fromItems.findIndex((item: FileSystemItem): boolean => item.id === fromNode.itemData?.id);
fromItems.splice(fromIndex, 1);
const toIndex = toNode === null || isDropInsideItem
? toItems.length
: toItems.findIndex((item: FileSystemItem): boolean => item.id === toNode.itemData?.id);
toItems.splice(toIndex, 0, fromNode.itemData);
moveChildren(fromNode, fromItems, toItems);
if (isDropInsideItem) {
fromNode.itemData.parentId = toNode.itemData?.id;
} else {
fromNode.itemData.parentId = toNode != null
? toNode.itemData?.parentId
: undefined;
}
};
const moveChildren = (node: Node, fromDataSource: FileSystemItem[], toDataSource: FileSystemItem[]): void => {
if (!node.itemData?.isDirectory) {
return;
}
node.children?.forEach((child): void => {
if (child.itemData?.isDirectory) {
moveChildren(child, fromDataSource, toDataSource);
}
const fromIndex = fromDataSource.findIndex((item: FileSystemItem): boolean => item.id === child.itemData?.id);
fromDataSource.splice(fromIndex, 1);
if (child.itemData) {
toDataSource.splice(toDataSource.length, 0, child.itemData);
}
});
};
const isChildNode = (parentNode: Node, childNode: Node): boolean => {
let { parent } = childNode;
while (parent !== null) {
if (parent?.itemData?.id === parentNode.itemData?.id) {
return true;
}
parent = parent?.parent;
}
return false;
};
const getTopVisibleNode = (component: any) => {
const treeViewElement = component.element();
const treeViewTopPosition = treeViewElement.getBoundingClientRect().top;
const nodes = treeViewElement.querySelectorAll('.dx-treeview-node');
for (let i = 0; i < nodes.length; i += 1) {
const nodeTopPosition = nodes[i].getBoundingClientRect().top;
if (nodeTopPosition >= treeViewTopPosition) {
return nodes[i];
}
}
return null;
};
const App = () => {
const treeViewDriveCRef = useRef<TreeViewRef<FileSystemItem>>(null);
const treeViewDriveDRef = useRef<TreeViewRef<FileSystemItem>>(null);
const [itemsDriveC, setItemsDriveC] = useState<FileSystemItem[]>(originItemsDriveC);
const [itemsDriveD, setItemsDriveD] = useState<FileSystemItem[]>(originItemsDriveD);
const getTreeView = useCallback((driveName: string): ReturnType<TreeViewRef<FileSystemItem>['instance']> | undefined => (driveName === 'driveC'
? treeViewDriveCRef.current?.instance()
: treeViewDriveDRef.current?.instance()), []);
const onDragChange = useCallback((e: SortableTypes.DragChangeEvent): void => {
if (e.fromComponent === e.toComponent) {
const fromNode = findNode(getTreeView(e.fromData), e.fromIndex);
const toNode = findNode(getTreeView(e.toData), calculateToIndex(e));
if (fromNode !== null && toNode !== null && isChildNode(fromNode, toNode)) {
e.cancel = true;
}
}
}, [getTreeView]);
const onDragEnd = useCallback((e: SortableTypes.DragEndEvent): void => {
if (e.fromComponent === e.toComponent && e.fromIndex === e.toIndex) {
return;
}
const fromTreeView = getTreeView(e.fromData);
const toTreeView = getTreeView(e.toData);
const fromNode = findNode(fromTreeView, e.fromIndex);
const toNode = findNode(toTreeView, calculateToIndex(e));
if (e.dropInsideItem && toNode !== null && !toNode.itemData?.isDirectory) {
return;
}
const fromTopVisibleNode = getTopVisibleNode(e.fromComponent);
const toTopVisibleNode = getTopVisibleNode(e.toComponent);
const fromItems = getStateFieldName(e.fromData) === 'itemsDriveC'
? itemsDriveC
: itemsDriveD;
const toItems = getStateFieldName(e.toData) === 'itemsDriveC'
? itemsDriveC
: itemsDriveD;
if (fromNode && toNode) {
moveNode(fromNode, toNode, fromItems, toItems, e.dropInsideItem);
}
if (getStateFieldName(e.fromData) === 'itemsDriveC') {
setItemsDriveC([...fromItems]);
} else {
setItemsDriveD([...fromItems]);
}
if (getStateFieldName(e.toData) === 'itemsDriveC') {
setItemsDriveC([...toItems]);
} else {
setItemsDriveD([...toItems]);
}
fromTreeView?.scrollToItem(fromTopVisibleNode);
toTreeView?.scrollToItem(toTopVisibleNode);
}, [getTreeView, itemsDriveC, itemsDriveD, setItemsDriveC, setItemsDriveD]);
return (
<div className="form">
<div className="drive-panel">
<div className="drive-header dx-treeview-item"><div className="dx-treeview-item-content"><i className="dx-icon dx-icon-activefolder"></i><span>Drive C:</span></div></div>
<Sortable
filter=".dx-treeview-item"
group="shared"
data="driveC"
allowDropInsideItem={true}
allowReordering={true}
onDragChange={onDragChange}
onDragEnd={onDragEnd}
>
<TreeView
id="treeviewDriveC"
expandNodesRecursive={false}
dataStructure="plain"
ref={treeViewDriveCRef}
items={itemsDriveC}
width={250}
height={380}
displayExpr="name"
/>
</Sortable>
</div>
<div className="drive-panel">
<div className="drive-header dx-treeview-item"><div className="dx-treeview-item-content"><i className="dx-icon dx-icon-activefolder"></i><span>Drive D:</span></div></div>
<Sortable
filter=".dx-treeview-item"
group="shared"
data="driveD"
allowDropInsideItem={true}
allowReordering={true}
onDragChange={onDragChange}
onDragEnd={onDragEnd}
>
<TreeView
id="treeviewDriveD"
expandNodesRecursive={false}
dataStructure="plain"
ref={treeViewDriveDRef}
items={itemsDriveD}
width={250}
height={380}
displayExpr="name"
/>
</Sortable>
</div>
</div>
);
};
export default App;
import React, { useCallback, useRef, useState } from 'react';
import TreeView from 'devextreme-react/tree-view';
import Sortable from 'devextreme-react/sortable';
import { itemsDriveC as originItemsDriveC, itemsDriveD as originItemsDriveD } from './data.js';
const getStateFieldName = (driveName) => (driveName === 'driveC' ? 'itemsDriveC' : 'itemsDriveD');
const calculateToIndex = (e) => {
if (e.fromComponent !== e.toComponent || e.dropInsideItem) {
return e.toIndex;
}
return e.fromIndex && e.toIndex && (e.fromIndex >= e.toIndex ? e.toIndex : e.toIndex + 1);
};
const findNode = (treeView, index) => {
if (index === undefined) {
return null;
}
const nodeElement = treeView.element().querySelectorAll('.dx-treeview-node')[index];
if (nodeElement) {
return findNodeById(treeView.getNodes(), nodeElement.getAttribute('data-item-id'));
}
return null;
};
const findNodeById = (nodes, id) => {
for (let i = 0; i < nodes.length; i += 1) {
if (nodes[i].itemData?.id === id) {
return nodes[i];
}
if (nodes[i].children) {
const node = findNodeById(nodes[i].children ?? [], id);
if (node != null) {
return node;
}
}
}
return null;
};
const moveNode = (fromNode, toNode, fromItems, toItems, isDropInsideItem) => {
if (!fromNode.itemData || !toNode.itemData) {
return;
}
const fromIndex = fromItems.findIndex((item) => item.id === fromNode.itemData?.id);
fromItems.splice(fromIndex, 1);
const toIndex =
toNode === null || isDropInsideItem
? toItems.length
: toItems.findIndex((item) => item.id === toNode.itemData?.id);
toItems.splice(toIndex, 0, fromNode.itemData);
moveChildren(fromNode, fromItems, toItems);
if (isDropInsideItem) {
fromNode.itemData.parentId = toNode.itemData?.id;
} else {
fromNode.itemData.parentId = toNode != null ? toNode.itemData?.parentId : undefined;
}
};
const moveChildren = (node, fromDataSource, toDataSource) => {
if (!node.itemData?.isDirectory) {
return;
}
node.children?.forEach((child) => {
if (child.itemData?.isDirectory) {
moveChildren(child, fromDataSource, toDataSource);
}
const fromIndex = fromDataSource.findIndex((item) => item.id === child.itemData?.id);
fromDataSource.splice(fromIndex, 1);
if (child.itemData) {
toDataSource.splice(toDataSource.length, 0, child.itemData);
}
});
};
const isChildNode = (parentNode, childNode) => {
let { parent } = childNode;
while (parent !== null) {
if (parent?.itemData?.id === parentNode.itemData?.id) {
return true;
}
parent = parent?.parent;
}
return false;
};
const getTopVisibleNode = (component) => {
const treeViewElement = component.element();
const treeViewTopPosition = treeViewElement.getBoundingClientRect().top;
const nodes = treeViewElement.querySelectorAll('.dx-treeview-node');
for (let i = 0; i < nodes.length; i += 1) {
const nodeTopPosition = nodes[i].getBoundingClientRect().top;
if (nodeTopPosition >= treeViewTopPosition) {
return nodes[i];
}
}
return null;
};
const App = () => {
const treeViewDriveCRef = useRef(null);
const treeViewDriveDRef = useRef(null);
const [itemsDriveC, setItemsDriveC] = useState(originItemsDriveC);
const [itemsDriveD, setItemsDriveD] = useState(originItemsDriveD);
const getTreeView = useCallback(
(driveName) =>
driveName === 'driveC'
? treeViewDriveCRef.current?.instance()
: treeViewDriveDRef.current?.instance(),
[],
);
const onDragChange = useCallback(
(e) => {
if (e.fromComponent === e.toComponent) {
const fromNode = findNode(getTreeView(e.fromData), e.fromIndex);
const toNode = findNode(getTreeView(e.toData), calculateToIndex(e));
if (fromNode !== null && toNode !== null && isChildNode(fromNode, toNode)) {
e.cancel = true;
}
}
},
[getTreeView],
);
const onDragEnd = useCallback(
(e) => {
if (e.fromComponent === e.toComponent && e.fromIndex === e.toIndex) {
return;
}
const fromTreeView = getTreeView(e.fromData);
const toTreeView = getTreeView(e.toData);
const fromNode = findNode(fromTreeView, e.fromIndex);
const toNode = findNode(toTreeView, calculateToIndex(e));
if (e.dropInsideItem && toNode !== null && !toNode.itemData?.isDirectory) {
return;
}
const fromTopVisibleNode = getTopVisibleNode(e.fromComponent);
const toTopVisibleNode = getTopVisibleNode(e.toComponent);
const fromItems = getStateFieldName(e.fromData) === 'itemsDriveC' ? itemsDriveC : itemsDriveD;
const toItems = getStateFieldName(e.toData) === 'itemsDriveC' ? itemsDriveC : itemsDriveD;
if (fromNode && toNode) {
moveNode(fromNode, toNode, fromItems, toItems, e.dropInsideItem);
}
if (getStateFieldName(e.fromData) === 'itemsDriveC') {
setItemsDriveC([...fromItems]);
} else {
setItemsDriveD([...fromItems]);
}
if (getStateFieldName(e.toData) === 'itemsDriveC') {
setItemsDriveC([...toItems]);
} else {
setItemsDriveD([...toItems]);
}
fromTreeView?.scrollToItem(fromTopVisibleNode);
toTreeView?.scrollToItem(toTopVisibleNode);
},
[getTreeView, itemsDriveC, itemsDriveD, setItemsDriveC, setItemsDriveD],
);
return (
<div className="form">
<div className="drive-panel">
<div className="drive-header dx-treeview-item">
<div className="dx-treeview-item-content">
<i className="dx-icon dx-icon-activefolder"></i>
<span>Drive C:</span>
</div>
</div>
<Sortable
filter=".dx-treeview-item"
group="shared"
data="driveC"
allowDropInsideItem={true}
allowReordering={true}
onDragChange={onDragChange}
onDragEnd={onDragEnd}
>
<TreeView
id="treeviewDriveC"
expandNodesRecursive={false}
dataStructure="plain"
ref={treeViewDriveCRef}
items={itemsDriveC}
width={250}
height={380}
displayExpr="name"
/>
</Sortable>
</div>
<div className="drive-panel">
<div className="drive-header dx-treeview-item">
<div className="dx-treeview-item-content">
<i className="dx-icon dx-icon-activefolder"></i>
<span>Drive D:</span>
</div>
</div>
<Sortable
filter=".dx-treeview-item"
group="shared"
data="driveD"
allowDropInsideItem={true}
allowReordering={true}
onDragChange={onDragChange}
onDragEnd={onDragEnd}
>
<TreeView
id="treeviewDriveD"
expandNodesRecursive={false}
dataStructure="plain"
ref={treeViewDriveDRef}
items={itemsDriveD}
width={250}
height={380}
displayExpr="name"
/>
</Sortable>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { FileSystemItem } from './types';
export const itemsDriveD: FileSystemItem[] = [];
export const itemsDriveC: FileSystemItem[] = [{
id: '1',
name: 'Documents',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '2',
parentId: '1',
name: 'Projects',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '3',
parentId: '2',
name: 'About.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '4',
parentId: '2',
name: 'Passwords.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '5',
parentId: '2',
name: 'About.xml',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '6',
parentId: '2',
name: 'Managers.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '7',
parentId: '2',
name: 'ToDo.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '8',
name: 'Images',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '9',
parentId: '8',
name: 'logo.png',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '10',
parentId: '8',
name: 'banner.gif',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '11',
name: 'System',
icon: 'activefolder',
isDirectory: true,
expanded: true,
}, {
id: '12',
parentId: '11',
name: 'Employees.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '13',
parentId: '11',
name: 'PasswordList.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '14',
name: 'Description.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
}, {
id: '15',
name: 'Description.txt',
icon: 'file',
isDirectory: false,
expanded: true,
}];
export interface FileSystemItem {
id: string;
parentId?: string;
name: string;
icon: string;
isDirectory: boolean;
expanded?: boolean;
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const itemsDriveD = [];
export const itemsDriveC = [
{
id: '1',
name: 'Documents',
icon: 'activefolder',
isDirectory: true,
expanded: true,
},
{
id: '2',
parentId: '1',
name: 'Projects',
icon: 'activefolder',
isDirectory: true,
expanded: true,
},
{
id: '3',
parentId: '2',
name: 'About.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '4',
parentId: '2',
name: 'Passwords.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '5',
parentId: '2',
name: 'About.xml',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '6',
parentId: '2',
name: 'Managers.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '7',
parentId: '2',
name: 'ToDo.txt',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '8',
name: 'Images',
icon: 'activefolder',
isDirectory: true,
expanded: true,
},
{
id: '9',
parentId: '8',
name: 'logo.png',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '10',
parentId: '8',
name: 'banner.gif',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '11',
name: 'System',
icon: 'activefolder',
isDirectory: true,
expanded: true,
},
{
id: '12',
parentId: '11',
name: 'Employees.txt',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '13',
parentId: '11',
name: 'PasswordList.txt',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '14',
name: 'Description.rtf',
icon: 'file',
isDirectory: false,
expanded: true,
},
{
id: '15',
name: 'Description.txt',
icon: 'file',
isDirectory: false,
expanded: true,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form {
display: flex;
}
.form > div {
display: inline-block;
vertical-align: top;
}
.dx-treeview-item {
box-sizing: border-box;
}
.drive-header {
min-height: auto;
padding: 0;
cursor: default;
margin-bottom: 10px;
}
.drive-panel {
padding: 20px 30px;
font-size: 115%;
font-weight: bold;
border-right: 1px solid rgba(165, 165, 165, 0.4);
height: 100%;
}
.drive-panel:last-of-type {
border-right: none;
}